Imports System.Drawing.Design
Imports System.ComponentModel

Public Class LedControl
    ' Our LinesOn values.
    ' Delegated to the Labels' BackColor properties.
    <EditorAttribute(GetType(LedControlEditor), GetType(UITypeEditor))> _
    Public Property LedLinesOn() As Boolean()
        Get
            Dim labels() As Label = {Label0, Label1, Label2, Label3, Label4, Label5, Label6}
            Dim lines_on(0 To labels.Length - 1) As Boolean
            For i As Integer = 0 To labels.Length - 1
                lines_on(i) = labels(i).BackColor = Color.Red
            Next i
            Return lines_on
        End Get
        Set(ByVal value() As Boolean)
            Dim labels() As Label = {Label0, Label1, Label2, Label3, Label4, Label5, Label6}
            For i As Integer = 0 To labels.Length - 1
                If value(i) Then
                    labels(i).BackColor = Color.Red
                Else
                    labels(i).BackColor = SystemColors.Control
                End If
            Next i
        End Set
    End Property

    ' The thickness of the Labels.
    Private m_BarWidth As Integer = 8
    Public Property LedBarWidth() As Integer
        Get
            Return m_BarWidth
        End Get
        Set(ByVal value As Integer)
            m_BarWidth = value
            ArrangeControls()
        End Set
    End Property

    ' Determines whether the labels display borders.
    Public Property LedShowBarEdges() As Boolean
        Get
            Return (Label0.BorderStyle = Windows.Forms.BorderStyle.FixedSingle)
        End Get
        Set(ByVal value As Boolean)
            Dim labels() As Label = {Label0, Label1, Label2, Label3, Label4, Label5, Label6}
            If value Then
                For i As Integer = 0 To labels.Length - 1
                    labels(i).BorderStyle = Windows.Forms.BorderStyle.FixedSingle
                Next i
            Else
                For i As Integer = 0 To labels.Length - 1
                    labels(i).BorderStyle = Windows.Forms.BorderStyle.None
                Next i
            End If
        End Set
    End Property

    ' Arrange the labels.
    Private Sub LedControlEditorControl_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        ArrangeControls()
    End Sub

    ' Arrange the labels.
    Private Sub ArrangeControls()
        Dim wid As Integer = Me.ClientSize.Width - 2 * m_BarWidth
        Dim hgt As Integer = (Me.ClientSize.Height - 3 * m_BarWidth) \ 2
        Label0.SetBounds(0, m_BarWidth, m_BarWidth, hgt)
        Label1.SetBounds(m_BarWidth, 0, wid, m_BarWidth)
        Label2.SetBounds(wid + m_BarWidth, m_BarWidth, m_BarWidth, hgt)
        Label3.SetBounds(m_BarWidth, hgt + m_BarWidth, wid, m_BarWidth)
        Label4.SetBounds(0, hgt + 2 * m_BarWidth, m_BarWidth, hgt)
        Label5.SetBounds(m_BarWidth, 2 * hgt + 2 * m_BarWidth, wid, m_BarWidth)
        Label6.SetBounds(wid + m_BarWidth, hgt + 2 * m_BarWidth, m_BarWidth, hgt)
    End Sub

    ' Toggle this label's background color.
    Private Sub Label_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label0.Click, Label1.Click, Label2.Click, Label3.Click, Label4.Click, Label5.Click, Label6.Click
        If Not Me.Enabled Then Exit Sub

        Dim the_label As Label = DirectCast(sender, Label)
        If the_label.BackColor = Color.Red Then
            the_label.BackColor = SystemColors.Control
        Else
            the_label.BackColor = Color.Red
        End If
    End Sub
End Class
